.\" -*- nroff -*-
.TH GROLJ4 @MAN1EXT@ "@MDATE@" "Groff Version @VERSION@"
.SH NAME
grolj4 \- groff driver for HP Laserjet 4 family
.
.
.\" license
.de co
Copyright \[co] 1994-2014 Free Software Foundation, Inc.

Permission is granted to make and distribute verbatim copies of
this manual provided the copyright notice and this permission notice
are preserved on all copies.

Permission is granted to copy and distribute modified versions of this
manual under the conditions for verbatim copying, provided that the
entire resulting derived work is distributed under the terms of a
permission notice identical to this one.

Permission is granted to copy and distribute translations of this
manual into another language, under the above conditions for modified
versions, except that this permission notice may be included in
translations approved by the Free Software Foundation instead of in
the original English.
..
.
.\" Like TP, but if specified indent is more than half
.\" the current line-length - indent, use the default indent.
.de Tp
. ie \\n(.$=0:((0\\$1)*2u>(\\n(.lu-\\n(.iu)) .TP
. el .TP "\\$1"
..
.
.\" --------------------------------------------------------------------
.SH SYNOPSIS
.\" --------------------------------------------------------------------
.
.nr a \n(.j
.ad l
.nr i \n(.i
.in +\w'\fBgrolj4 'u
.ti \niu
.B grolj4
.
.de OP
.  ie \\n(.$-1 .RI "[\ \fB\\$1\fP" "\\$2" "\ ]"
.  el .RB "[\ " "\\$1" "\ ]"
..
.
.OP \-lv
.OP \-d \fR[\fPn\fR]\fP
.OP \-c n
.OP \-p paper_size
.OP \-w n
.OP \-F dir
.RI "[\ " files\|.\|.\|. "\ ]"
.br
.ad \na
.
.
.\" --------------------------------------------------------------------
.SH DESCRIPTION
.\" --------------------------------------------------------------------
.
.B grolj4
is a driver for
.B groff
that produces output in PCL5 format suitable for an HP Laserjet 4
printer.
.
.
.LP
There is an additional drawing command available:
.
.TP
.BI \eD'R\  dh\ dv '
Draw a rule (solid black rectangle), with one corner at the current
position, and the diagonally opposite corner at the current position
.RI +( dh , dv ).
.
Afterwards the current position will be at the opposite corner.
.
This generates a PCL fill rectangle command, and so will work on
printers that do not support HPGL/2 unlike the other
.B \eD
commands.
.
.
.\" --------------------------------------------------------------------
.SH OPTIONS
.\" --------------------------------------------------------------------
.
It is possible to have whitespace between a command line option and its
parameter.
.
.TP
.BI \-c n
Print
.I n
copies of each page.
.
.TP
.B \-l
Print the document with a landscape orientation.
.
.TP
.BI "\-d [" n ]
Use duplex mode
.IR n :
1\ is long-side binding; 2\ is short-side binding;
default is\ 1.
.
.TP
.BI \-p size
Set the paper size to
.IR size ,
which must be one of
letter, legal, executive, a4, com10, monarch, c5, b5, dl.
.
.TP
.B \-v
Print the version number.
.
.TP
.BI \-w n
Set the default line thickness to
.I n
thousandths of an em.
.
If this option isn\[aq]t specified, the line thickness defaults to
0.04\~em.
.
.TP
.BI \-F dir
Prepend directory
.IB dir /dev name
to the search path for font and device description files;
.I name
is the name of the device, usually
.BR lj4 .
.
.
.LP
The following four commands are available additionally in the
font description files:
.
.TP
.BI pclweight \ N
The integer value
.I N
must be in the range \-7 to +7; default is\~0.
.
.TP
.BI pclstyle \ N
The integer value
.I N
must be in the range 0 to 32767; default is\~0.
.
.TP
.BI pclproportional \ N
A boolean flag which can be either 0 or\~1; default is\~0.
.
.TP
.BI pcltypeface \ N
The integer value
.I N
must be in the range 0 to 65535; default is\~0.
.
.
.\" --------------------------------------------------------------------
.SH ENVIRONMENT
.\" --------------------------------------------------------------------
.
.TP
.SM
.B GROFF_FONT_PATH
A list of directories in which to search for the
.BI dev name
directory in addition to the default ones.
.
See
.BR @g@troff (@MAN1EXT@)
and
.BR \%groff_font (@MAN5EXT@)
for more details.
.
.
.\" --------------------------------------------------------------------
.SH FILES
.\" --------------------------------------------------------------------
.
.TP
.B @FONTDIR@/devlj4/DESC
Device description file.
.
.TP
.BI @FONTDIR@/devlj4/ F
Font description file for font
.IR F .
.
.TP
.B @MACRODIR@/lj4.tmac
Macros for use with
.BR grolj4 .
.
.
.SH BUGS
Small dots.
.
.
.\" --------------------------------------------------------------------
.SH "SEE ALSO"
.\" --------------------------------------------------------------------
.
.BR lj4_font (@MAN5EXT@),
.BR groff (@MAN1EXT@),
.BR @g@troff (@MAN1EXT@),
.BR groff_out (@MAN5EXT@),
.BR groff_font (@MAN5EXT@),
.BR groff_char (@MAN7EXT@)
.
.
.\" --------------------------------------------------------------------
.SH COPYING
.\" --------------------------------------------------------------------
.co
